// Настройка напровления движения +
const bool inv_x = 0;                         // Если при колибровке системы моторы двигаются в неправельных направлениях, то
const bool inv_y = 1;                         // задайте переменных значение 1, в этом случаи направление их измениться

bool turns_left_x   = 0;
bool turns_right_x  = 1;
bool turns_left_y   = 0;
bool turns_right_y  = 1;

// Расстояние по осям +
/*const float angle_of_step = 1.8;                    // Угол за один шаг (Step Angle): 1.8 градуса;
  const float sheave_diameter = 11.0;                 // Диаметр зубчатого шкива, мм
  double step_length = (PI * sheave_diameter * angle_of_step) / 180;// Пройденное расстояние за один шаг*/

int steps_on_turn = 200;
float step_of_belt = 2;
int count_teeth = 16;
double step_length = (step_of_belt * count_teeth) / steps_on_turn;

// Время между шагами (Скорость)
const int time_del = 3000;

// Расположение портов для расширяющей платы CNC Shield v3, на драйверах DRV8825
const int StepX = 2;                          // Порты шагового двигателя X (левого)
const int DirX = 5;
const int StepY = 3;                          // Порты шагового двигателя Y (правого)
const int DirY = 6;
const int ButX = 9;                           // Порты концевых кнопок (концевиков)
const int ButY = 10;

// Размеры рабочей зоны
const int real_x = 130;
const int real_y = 130;


int input() {                                 // Функция ввода параметров из консоли
  bool flag = true;
  int in_value;
  while (flag) {
    if (Serial.available() > 0) {
      in_value = Serial.parseInt();
      if (in_value != 0) return in_value;     // Для предовращения бага (произвольное появление 0 в консоле)
    }
  }
}


// Вычисляет среднее значение
double mean(int pause, int n) {
  int sum = 0;
  for (int i = 0; i < n; i++) {
    // Производится чтение с датчика и суммироуется с другими результатами
    sum += analogRead(A3);
    // Пауза
    delay(pause);
  }
  // Возвращает средний параметр на одной точке
  return ((double)sum) / n;
}


// Возвращает: true - положительное, false - отрицательное число
bool positive(float input_num) {
  return (input_num >= 0.0);
}


/*Функции выбора напрвления:                                  Y
      Если X = 0 и Y = 0 - Движение на Вправо                 ↑
      Если X = 1 и Y = 1 - Движение на Влево                  |
      Если X = 0 и Y = 1 - Движение на Вверх                  |
      Если X = 1 и Y = 0 - Движение на Вниз          X ← - - O
*/

//Нарпавление по X. true - влево; false - вправо
void forwardX(bool input_forw) {
  input_forw = input_forw ^ inv_x;
  digitalWrite(DirX, input_forw ^ turns_left_x);
  digitalWrite(DirY, input_forw ^ turns_left_y);
}
//Нарпавление по Y. true - вверх; false - вниз
void forwardY(bool input_forw) {
  input_forw = input_forw ^ inv_y;
  digitalWrite(DirX, input_forw ^ turns_right_x);
  digitalWrite(DirY, input_forw ^ turns_left_y);
}


/*       Возврат домой по осям        */
// Функция возврата по оси X
void homeX () {

  // Выбор направления вращения
  forwardX(false);

  // Прокрутка по оси X, до 0 точки
  while (digitalRead(ButX)) {
    digitalWrite(StepX, HIGH);
    digitalWrite(StepY, HIGH);
    delayMicroseconds(time_del);
    digitalWrite(StepX, LOW);
    digitalWrite(StepY, LOW);
    delayMicroseconds(time_del);
  }
}

// Функция возврата по оси Y
void homeY () {

  // Выбор направления вращения
  forwardY(false);

  // Прокрутка по оси Y, до 0 точки
  while (digitalRead(ButY)) {
    digitalWrite(StepX, HIGH);
    digitalWrite(StepY, HIGH);
    delayMicroseconds(time_del);
    digitalWrite(StepX, LOW);
    digitalWrite(StepY, LOW);
    delayMicroseconds(time_del);
  }
}

// Функция возврата по всем осям
void homeAll() {
  homeX();
  homeY();
}


/*        Сдвиги по координатам         */
// Функция сдвига по оси X.
// Параметр расстояния - сдвиг в милиметрах
void shiftX(float input_x) {

  // Выбор направления вращения
  forwardX(positive(input_x));

  int steps = abs(input_x) / step_length;            // Вычисление количества шагов, расстояние / шаг
  for (int i = 0; i < steps; i++) {             // Цикл повторяющий Step количество раз один шаг
    digitalWrite(StepY, HIGH);
    digitalWrite(StepX, HIGH);
    delayMicroseconds(time_del);
    digitalWrite(StepY, LOW);
    digitalWrite(StepX, LOW);
    delayMicroseconds(time_del);
  }
}

// Функция сдвига по оси Y.
// Параметр расстояния - сдвиг в милиметрах
void shiftY(float input_y) {

  // Выбор направления вращения
  forwardY(positive(input_y));

  int steps = abs(input_y) / step_length;            // Вычисление количества шагов, расстояние / шаг
  for (int i = 0; i < steps; i++) {             // Цикл повторяющий Step количество раз один шаг
    digitalWrite(StepY, HIGH);
    digitalWrite(StepX, HIGH);
    delayMicroseconds(time_del);
    digitalWrite(StepY, LOW);
    digitalWrite(StepX, LOW);
    delayMicroseconds(time_del);
  }
}

// Функция сдвига
// Параметр расстояния - сдвиг в милиметрах
void shift(float input_y, float input_x) {
  shiftY(input_y);
  shiftX(input_x);
}


// Сканирование рабочей зоны
void scanArea(int count_x, int count_y, double** input_mass) {
  for (int i = 0; i < count_y - 1; i++) {                                     //Поднимаемся count_y - 1 раз
    if (i % 2 == 0) {
      for (int j = 0; j < count_x - 1; j++) {
        input_mass[i][j] = mean(50, 10);
        shiftX(real_x / (count_x - 1));
      }
      input_mass[i][count_x - 1] = mean(50, 10);
    }
    else {
      input_mass[i][count_x - 1] = mean(50, 10);
      for (int j = count_x - 2; j >= 0; j--) {
        shiftX(-real_x / (count_x - 1));
        input_mass[i][j] = mean(50, 10);
      }
    }
    shiftY(real_y / (count_y - 1));
  }
  // Отдельно проходим последнию точку
  if (count_y % 2 != 0) {
      for (int j = 0; j < count_x - 1; j++) {
        input_mass[count_y - 1][j] = mean(50, 10);
        shiftX(real_x / (count_x - 1));
      }
      input_mass[count_y - 1][count_x - 1] = mean(50, 10);
    }
    else {
      input_mass[count_y - 1][count_x - 1] = mean(50, 10);
      for (int j = count_x - 2; j >= 0; j--) {
        shiftX(-real_x / (count_x - 1));
        input_mass[count_y - 1][j] = mean(50, 10);
      }
    }
}
